// -*- c-basic-offset: 4; tab-width: 8; indent-tabs-mode: t -*-

// Copyright (c) 2001-2003 International Computer Science Institute
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software")
// to deal in the Software without restriction, subject to the conditions
// listed in the XORP LICENSE file. These conditions include: you must
// preserve this copyright notice, and you cannot mention the copyright
// holders in advertising related to the Software without their permission.
// The Software is provided WITHOUT ANY WARRANTY, EXPRESS OR IMPLIED. This
// notice is a summary of the XORP LICENSE file; the license in that file is
// legally binding.

// $XORP: xorp/rtrmgr/master_conf_tree_node.hh,v 1.2 2003/03/10 23:21:00 hodson Exp $

#ifndef __RTRMGR_MASTER_CONF_TREE_NODE_HH__
#define __RTRMGR_MASTER_CONF_TREE_NODE_HH__

#include <map>
#include <list>
#include <set>
#include <vector>
#include <sys/time.h>
#include "config.h"
#include "libxorp/xorp.h"
#include "module_manager.hh"
#include "xorp_client.hh"
#include "conf_tree_node.hh"

class RouterCLI;
class CommandTree;
class TemplateTreeNode;
class Command;

class MasterConfigTreeNode : public ConfigTreeNode {
public:
    MasterConfigTreeNode(const string &node_name, 
			 const string &path, 
			 const TemplateTreeNode *ttn, 
			 MasterConfigTreeNode *parent, 
			 uid_t user_id);

    //adaptors so we don't need to cast elsewhere
    inline MasterConfigTreeNode* parent() {
	return (MasterConfigTreeNode*)_parent;
    }
protected:
private:
    //don't add any storage here, MasterConfigTreeNode needs to be the
    //same size as ConfigTreeNode
};

#endif // __RTRMGR_MASTER_CONF_TREE_NODE_HH__
