/*
 * Copyright (c) 2001-2003 International Computer Science Institute
 * See LICENSE file for licensing, conditions, and warranties on use.
 *
 * DO NOT EDIT THIS FILE - IT IS PROGRAMMATICALLY GENERATED
 *
 * Generated by 'tgt-gen'.
 *
 * $XORP: xorp/xrl/targets/fea_base.hh,v 1.28 2003/10/28 19:36:28 pavlin Exp $
 */


#ifndef __XRL_INTERFACES_FEA_BASE_HH__
#define __XRL_INTERFACES_FEA_BASE_HH__

#undef XORP_LIBRARY_NAME
#define XORP_LIBRARY_NAME "XrlFeaTarget"

#include "libxorp/xlog.h"
#include "libxipc/xrl_cmd_map.hh"

class XrlFeaTargetBase {
protected:
    XrlCmdMap* _cmds;

public:
    XrlFeaTargetBase(XrlCmdMap* cmds) : _cmds(cmds) { add_handlers(); }
    virtual ~XrlFeaTargetBase() { remove_handlers(); }

    inline const string& name() const { return _cmds->name(); }
    inline const char* version() const { return "fea/0.0"; }

protected:

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get name of Xrl Target
     */
    virtual XrlCmdError common_0_1_get_target_name(
	// Output values, 
	string&	name) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get version string from Xrl Target
     */
    virtual XrlCmdError common_0_1_get_version(
	// Output values, 
	string&	version) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get status of Xrl Target
     */
    virtual XrlCmdError common_0_1_get_status(
	// Output values, 
	uint32_t&	status, 
	string&	reason) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Request clean shutdown of Xrl Target
     */
    virtual XrlCmdError common_0_1_shutdown() = 0;

    virtual XrlCmdError ifmgr_0_1_get_configured_interface_names(
	// Output values, 
	XrlAtomList&	ifnames) = 0;

    virtual XrlCmdError ifmgr_0_1_get_configured_vif_names(
	// Input values, 
	const string&	ifname, 
	// Output values, 
	XrlAtomList&	vifs) = 0;

    virtual XrlCmdError ifmgr_0_1_get_configured_vif_flags(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	// Output values, 
	bool&	enabled, 
	bool&	broadcast, 
	bool&	loopback, 
	bool&	point_to_point, 
	bool&	multicast) = 0;

    virtual XrlCmdError ifmgr_0_1_get_configured_vif_pif_index(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	// Output values, 
	uint32_t&	pif_index) = 0;

    virtual XrlCmdError ifmgr_0_1_get_configured_vif_addresses4(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	// Output values, 
	XrlAtomList&	addresses) = 0;

    virtual XrlCmdError ifmgr_0_1_get_configured_vif_addresses6(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	// Output values, 
	XrlAtomList&	addresses) = 0;

    virtual XrlCmdError ifmgr_0_1_get_configured_address_flags4(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	const IPv4&	address, 
	// Output values, 
	bool&	enabled, 
	bool&	broadcast, 
	bool&	loopback, 
	bool&	point_to_point, 
	bool&	multicast) = 0;

    virtual XrlCmdError ifmgr_0_1_get_configured_address_flags6(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	const IPv6&	address, 
	// Output values, 
	bool&	enabled, 
	bool&	loopback, 
	bool&	point_to_point, 
	bool&	multicast) = 0;

    virtual XrlCmdError ifmgr_0_1_get_configured_interface_enabled(
	// Input values, 
	const string&	ifname, 
	// Output values, 
	bool&	enabled) = 0;

    virtual XrlCmdError ifmgr_0_1_get_configured_mac(
	// Input values, 
	const string&	ifname, 
	// Output values, 
	Mac&	mac) = 0;

    virtual XrlCmdError ifmgr_0_1_get_configured_mtu(
	// Input values, 
	const string&	ifname, 
	// Output values, 
	uint32_t&	mtu) = 0;

    virtual XrlCmdError ifmgr_0_1_get_configured_vif_enabled(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	// Output values, 
	bool&	enabled) = 0;

    virtual XrlCmdError ifmgr_0_1_get_configured_prefix4(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	const IPv4&	address, 
	// Output values, 
	uint32_t&	prefix_len) = 0;

    virtual XrlCmdError ifmgr_0_1_get_configured_broadcast4(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	const IPv4&	address, 
	// Output values, 
	IPv4&	broadcast) = 0;

    virtual XrlCmdError ifmgr_0_1_get_configured_endpoint4(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	const IPv4&	address, 
	// Output values, 
	IPv4&	endpoint) = 0;

    virtual XrlCmdError ifmgr_0_1_get_configured_prefix6(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	const IPv6&	address, 
	// Output values, 
	uint32_t&	prefix_len) = 0;

    virtual XrlCmdError ifmgr_0_1_get_configured_endpoint6(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	const IPv6&	address, 
	// Output values, 
	IPv6&	endpoint) = 0;

    virtual XrlCmdError ifmgr_0_1_start_transaction(
	// Output values, 
	uint32_t&	tid) = 0;

    virtual XrlCmdError ifmgr_0_1_commit_transaction(
	// Input values, 
	const uint32_t&	tid) = 0;

    virtual XrlCmdError ifmgr_0_1_abort_transaction(
	// Input values, 
	const uint32_t&	tid) = 0;

    virtual XrlCmdError ifmgr_0_1_create_interface(
	// Input values, 
	const uint32_t&	tid, 
	const string&	ifname) = 0;

    virtual XrlCmdError ifmgr_0_1_delete_interface(
	// Input values, 
	const uint32_t&	tid, 
	const string&	ifname) = 0;

    virtual XrlCmdError ifmgr_0_1_set_interface_enabled(
	// Input values, 
	const uint32_t&	tid, 
	const string&	ifname, 
	const bool&	enabled) = 0;

    virtual XrlCmdError ifmgr_0_1_set_mac(
	// Input values, 
	const uint32_t&	tid, 
	const string&	ifname, 
	const Mac&	mac) = 0;

    virtual XrlCmdError ifmgr_0_1_set_mtu(
	// Input values, 
	const uint32_t&	tid, 
	const string&	ifname, 
	const uint32_t&	mtu) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Create a vif
     *  
     *  @param ifname the name of the physical interface associated with the
     *  new vif.
     *  
     *  @param vif name for new vif, must be unique across all the vifs in the
     *  system.
     */
    virtual XrlCmdError ifmgr_0_1_create_vif(
	// Input values, 
	const uint32_t&	tid, 
	const string&	ifname, 
	const string&	vif) = 0;

    virtual XrlCmdError ifmgr_0_1_delete_vif(
	// Input values, 
	const uint32_t&	tid, 
	const string&	ifname, 
	const string&	vif) = 0;

    virtual XrlCmdError ifmgr_0_1_set_vif_enabled(
	// Input values, 
	const uint32_t&	tid, 
	const string&	ifname, 
	const string&	vif, 
	const bool&	enabled) = 0;

    virtual XrlCmdError ifmgr_0_1_create_address4(
	// Input values, 
	const uint32_t&	tid, 
	const string&	ifname, 
	const string&	vif, 
	const IPv4&	address) = 0;

    virtual XrlCmdError ifmgr_0_1_delete_address4(
	// Input values, 
	const uint32_t&	tid, 
	const string&	ifname, 
	const string&	vif, 
	const IPv4&	address) = 0;

    virtual XrlCmdError ifmgr_0_1_set_address_enabled4(
	// Input values, 
	const uint32_t&	tid, 
	const string&	ifname, 
	const string&	vif, 
	const IPv4&	address, 
	const bool&	enabled) = 0;

    virtual XrlCmdError ifmgr_0_1_get_configured_address_enabled4(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	const IPv4&	address, 
	// Output values, 
	bool&	enabled) = 0;

    virtual XrlCmdError ifmgr_0_1_set_prefix4(
	// Input values, 
	const uint32_t&	tid, 
	const string&	ifname, 
	const string&	vif, 
	const IPv4&	address, 
	const uint32_t&	prefix_len) = 0;

    virtual XrlCmdError ifmgr_0_1_set_broadcast4(
	// Input values, 
	const uint32_t&	tid, 
	const string&	ifname, 
	const string&	vif, 
	const IPv4&	address, 
	const IPv4&	broadcast) = 0;

    virtual XrlCmdError ifmgr_0_1_set_endpoint4(
	// Input values, 
	const uint32_t&	tid, 
	const string&	ifname, 
	const string&	vif, 
	const IPv4&	address, 
	const IPv4&	endpoint) = 0;

    virtual XrlCmdError ifmgr_0_1_create_address6(
	// Input values, 
	const uint32_t&	tid, 
	const string&	ifname, 
	const string&	vif, 
	const IPv6&	address) = 0;

    virtual XrlCmdError ifmgr_0_1_delete_address6(
	// Input values, 
	const uint32_t&	tid, 
	const string&	ifname, 
	const string&	vif, 
	const IPv6&	address) = 0;

    virtual XrlCmdError ifmgr_0_1_set_address_enabled6(
	// Input values, 
	const uint32_t&	tid, 
	const string&	ifname, 
	const string&	vif, 
	const IPv6&	address, 
	const bool&	enabled) = 0;

    virtual XrlCmdError ifmgr_0_1_get_configured_address_enabled6(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	const IPv6&	address, 
	// Output values, 
	bool&	enabled) = 0;

    virtual XrlCmdError ifmgr_0_1_set_prefix6(
	// Input values, 
	const uint32_t&	tid, 
	const string&	ifname, 
	const string&	vif, 
	const IPv6&	address, 
	const uint32_t&	prefix_len) = 0;

    virtual XrlCmdError ifmgr_0_1_set_endpoint6(
	// Input values, 
	const uint32_t&	tid, 
	const string&	ifname, 
	const string&	vif, 
	const IPv6&	address, 
	const IPv6&	endpoint) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Register network interface observer for configured interfaces.
     *  
     *  @param clientname name of xrl entity supporting fea_ifmgr_client.xif
     *  methods.
     */
    virtual XrlCmdError ifmgr_0_1_register_client(
	// Input values, 
	const string&	clientname) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Unregister network interface observer for configured interfaces. This
     *  method is not strictly necessary, the fea will remove the interface
     *  observer from its list of known observers if interface update XRLs
     *  fail.
     */
    virtual XrlCmdError ifmgr_0_1_unregister_client(
	// Input values, 
	const string&	clientname) = 0;

    virtual XrlCmdError ifmgr_0_1_get_system_interface_names(
	// Output values, 
	XrlAtomList&	ifnames) = 0;

    virtual XrlCmdError ifmgr_0_1_get_system_vif_names(
	// Input values, 
	const string&	ifname, 
	// Output values, 
	XrlAtomList&	vifs) = 0;

    virtual XrlCmdError ifmgr_0_1_get_system_vif_flags(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	// Output values, 
	bool&	enabled, 
	bool&	broadcast, 
	bool&	loopback, 
	bool&	point_to_point, 
	bool&	multicast) = 0;

    virtual XrlCmdError ifmgr_0_1_get_system_vif_pif_index(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	// Output values, 
	uint32_t&	pif_index) = 0;

    virtual XrlCmdError ifmgr_0_1_get_system_vif_addresses4(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	// Output values, 
	XrlAtomList&	addresses) = 0;

    virtual XrlCmdError ifmgr_0_1_get_system_address_flags4(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	const IPv4&	address, 
	// Output values, 
	bool&	enabled, 
	bool&	broadcast, 
	bool&	loopback, 
	bool&	point_to_point, 
	bool&	multicast) = 0;

    virtual XrlCmdError ifmgr_0_1_get_system_vif_addresses6(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	// Output values, 
	XrlAtomList&	addresses) = 0;

    virtual XrlCmdError ifmgr_0_1_get_system_address_flags6(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	const IPv6&	address, 
	// Output values, 
	bool&	enabled, 
	bool&	loopback, 
	bool&	point_to_point, 
	bool&	multicast) = 0;

    virtual XrlCmdError ifmgr_0_1_get_system_interface_enabled(
	// Input values, 
	const string&	ifname, 
	// Output values, 
	bool&	enabled) = 0;

    virtual XrlCmdError ifmgr_0_1_get_system_mac(
	// Input values, 
	const string&	ifname, 
	// Output values, 
	Mac&	mac) = 0;

    virtual XrlCmdError ifmgr_0_1_get_system_mtu(
	// Input values, 
	const string&	ifname, 
	// Output values, 
	uint32_t&	mtu) = 0;

    virtual XrlCmdError ifmgr_0_1_get_system_vif_enabled(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	// Output values, 
	bool&	enabled) = 0;

    virtual XrlCmdError ifmgr_0_1_get_system_prefix4(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	const IPv4&	address, 
	// Output values, 
	uint32_t&	prefix_len) = 0;

    virtual XrlCmdError ifmgr_0_1_get_system_broadcast4(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	const IPv4&	address, 
	// Output values, 
	IPv4&	broadcast) = 0;

    virtual XrlCmdError ifmgr_0_1_get_system_endpoint4(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	const IPv4&	address, 
	// Output values, 
	IPv4&	endpoint) = 0;

    virtual XrlCmdError ifmgr_0_1_get_system_prefix6(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	const IPv6&	address, 
	// Output values, 
	uint32_t&	prefix_len) = 0;

    virtual XrlCmdError ifmgr_0_1_get_system_endpoint6(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	const IPv6&	address, 
	// Output values, 
	IPv6&	endpoint) = 0;

    virtual XrlCmdError ifmgr_0_1_get_system_address_enabled4(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	const IPv4&	address, 
	// Output values, 
	bool&	enabled) = 0;

    virtual XrlCmdError ifmgr_0_1_get_system_address_enabled6(
	// Input values, 
	const string&	ifname, 
	const string&	vif, 
	const IPv6&	address, 
	// Output values, 
	bool&	enabled) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Register network interface observer for all system interfaces.
     *  
     *  @param clientname name of xrl entity supporting fea_ifmgr_client.xif
     *  methods.
     */
    virtual XrlCmdError ifmgr_0_1_register_system_interfaces_client(
	// Input values, 
	const string&	clientname) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Unregister network interface observer for all system interfaces. This
     *  method is not strictly necessary, the fea will remove the interface
     *  observer from its list of known observers if interface update XRLs
     *  fail.
     */
    virtual XrlCmdError ifmgr_0_1_unregister_system_interfaces_client(
	// Input values, 
	const string&	clientname) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Register remote mirror of interface state.
     */
    virtual XrlCmdError ifmgr_replicator_0_1_register_ifmgr_mirror(
	// Input values, 
	const string&	clientname) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Register remote mirror of interface state.
     */
    virtual XrlCmdError ifmgr_replicator_0_1_unregister_ifmgr_mirror(
	// Input values, 
	const string&	clientname) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Start transaction.
     *  
     *  @param tid the transaction ID to use for this transaction.
     */
    virtual XrlCmdError fti_0_2_start_transaction(
	// Output values, 
	uint32_t&	tid) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Commit transaction.
     *  
     *  @param tid the transaction ID of this transaction.
     */
    virtual XrlCmdError fti_0_2_commit_transaction(
	// Input values, 
	const uint32_t&	tid) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Abort transaction.
     *  
     *  @param tid the transaction ID of this transaction.
     */
    virtual XrlCmdError fti_0_2_abort_transaction(
	// Input values, 
	const uint32_t&	tid) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Add a routing entry.
     *  
     *  @param tid the transaction ID of this transaction.
     *  
     *  @param dst the destination subnet address of the entry.
     *  
     *  @param gateway the address of the next-hop router toward dst.
     *  
     *  @param ifname the name of the physical interface toward dst.
     *  
     *  @param vifname the name of the virtual interface toward dst.
     *  
     *  @param metric the routing metric toward dst.
     *  
     *  @param admin_distance the administratively defined distance toward dst.
     *  
     *  @param protocol_origin the name of the protocol that originated this
     *  entry.
     */
    virtual XrlCmdError fti_0_2_add_entry4(
	// Input values, 
	const uint32_t&	tid, 
	const IPv4Net&	dst, 
	const IPv4&	gateway, 
	const string&	ifname, 
	const string&	vifname, 
	const uint32_t&	metric, 
	const uint32_t&	admin_distance, 
	const string&	protocol_origin) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Add a routing entry.
     *  
     *  @param tid the transaction ID of this transaction.
     *  
     *  @param dst the destination subnet address of the entry.
     *  
     *  @param gateway the address of the next-hop router toward dst.
     *  
     *  @param ifname the name of the physical interface toward dst.
     *  
     *  @param vifname the name of the virtual interface toward dst.
     *  
     *  @param metric the routing metric toward dst.
     *  
     *  @param admin_distance the administratively defined distance toward dst.
     *  
     *  @param protocol_origin the name of the protocol that originated this
     *  entry.
     */
    virtual XrlCmdError fti_0_2_add_entry6(
	// Input values, 
	const uint32_t&	tid, 
	const IPv6Net&	dst, 
	const IPv6&	gateway, 
	const string&	ifname, 
	const string&	vifname, 
	const uint32_t&	metric, 
	const uint32_t&	admin_distance, 
	const string&	protocol_origin) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Delete a routing entry.
     *  
     *  @param tid the transaction ID of this transaction.
     *  
     *  @param dst the destination subnet address of the entry.
     */
    virtual XrlCmdError fti_0_2_delete_entry4(
	// Input values, 
	const uint32_t&	tid, 
	const IPv4Net&	dst) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Delete a routing entry.
     *  
     *  @param tid the transaction ID of this transaction.
     *  
     *  @param dst the destination subnet address of the entry.
     */
    virtual XrlCmdError fti_0_2_delete_entry6(
	// Input values, 
	const uint32_t&	tid, 
	const IPv6Net&	dst) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Delete all routing entries for all address families.
     *  
     *  @param tid the transaction ID of this transaction.
     */
    virtual XrlCmdError fti_0_2_delete_all_entries(
	// Input values, 
	const uint32_t&	tid) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Delete all routing entries for the IPv4 address family.
     *  
     *  @param tid the transaction ID of this transaction.
     */
    virtual XrlCmdError fti_0_2_delete_all_entries4(
	// Input values, 
	const uint32_t&	tid) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Delete all routing entries for the IPv6 address family.
     *  
     *  @param tid the transaction ID of this transaction.
     */
    virtual XrlCmdError fti_0_2_delete_all_entries6(
	// Input values, 
	const uint32_t&	tid) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Lookup a route for a destination host address.
     *  
     *  @param dst the destination host address to lookup.
     *  
     *  @param gateway the address of the next-hop router toward dst.
     *  
     *  @param ifname the name of the physical interface toward dst.
     *  
     *  @param vifname the name of the virtual interface toward dst.
     *  
     *  @param metric the routing metric toward dst.
     *  
     *  @param admin_distance the administratively defined distance toward dst.
     *  
     *  @param protocol_origin the name of the protocol that originated this
     *  entry.
     */
    virtual XrlCmdError fti_0_2_lookup_route4(
	// Input values, 
	const IPv4&	dst, 
	// Output values, 
	IPv4Net&	netmask, 
	IPv4&	gateway, 
	string&	ifname, 
	string&	vifname, 
	uint32_t&	metric, 
	uint32_t&	admin_distance, 
	string&	protocol_origin) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Lookup a route for a destination host address.
     *  
     *  @param dst the destination host address to lookup.
     *  
     *  @param gateway the address of the next-hop router toward dst.
     *  
     *  @param ifname the name of the physical interface toward dst.
     *  
     *  @param vifname the name of the virtual interface toward dst.
     *  
     *  @param metric the routing metric toward dst.
     *  
     *  @param admin_distance the administratively defined distance toward dst.
     *  
     *  @param protocol_origin the name of the protocol that originated this
     *  entry.
     */
    virtual XrlCmdError fti_0_2_lookup_route6(
	// Input values, 
	const IPv6&	dst, 
	// Output values, 
	IPv6Net&	netmask, 
	IPv6&	gateway, 
	string&	ifname, 
	string&	vifname, 
	uint32_t&	metric, 
	uint32_t&	admin_distance, 
	string&	protocol_origin) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Lookup a route for a destination subnet address.
     *  
     *  @param dst the destination subnet address to lookup.
     *  
     *  @param gateway the address of the next-hop router toward dst.
     *  
     *  @param ifname the name of the physical interface toward dst.
     *  
     *  @param vifname the name of the virtual interface toward dst.
     *  
     *  @param metric the routing metric toward dst.
     *  
     *  @param admin_distance the administratively defined distance toward dst.
     *  
     *  @param protocol_origin the name of the protocol that originated this
     *  entry.
     */
    virtual XrlCmdError fti_0_2_lookup_entry4(
	// Input values, 
	const IPv4Net&	dst, 
	// Output values, 
	IPv4&	gateway, 
	string&	ifname, 
	string&	vifname, 
	uint32_t&	metric, 
	uint32_t&	admin_distance, 
	string&	protocol_origin) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Lookup a route for a destination subnet address.
     *  
     *  @param dst the destination subnet address to lookup.
     *  
     *  @param gateway the address of the next-hop router toward dst.
     *  
     *  @param ifname the name of the physical interface toward dst.
     *  
     *  @param vifname the name of the virtual interface toward dst.
     *  
     *  @param metric the routing metric toward dst.
     *  
     *  @param admin_distance the administratively defined distance toward dst.
     *  
     *  @param protocol_origin the name of the protocol that originated this
     *  entry.
     */
    virtual XrlCmdError fti_0_2_lookup_entry6(
	// Input values, 
	const IPv6Net&	dst, 
	// Output values, 
	IPv6&	gateway, 
	string&	ifname, 
	string&	vifname, 
	uint32_t&	metric, 
	uint32_t&	admin_distance, 
	string&	protocol_origin) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Test if the underlying system supports IPv4.
     *  
     *  @param result true if the underlying system supports IPv4, otherwise
     *  false.
     */
    virtual XrlCmdError fti_0_2_have_ipv4(
	// Output values, 
	bool&	result) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Test if the underlying system supports IPv6.
     *  
     *  @param result true if the underlying system supports IPv4, otherwise
     *  false.
     */
    virtual XrlCmdError fti_0_2_have_ipv6(
	// Output values, 
	bool&	result) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Test whether the IPv4 unicast forwarding engine is enabled or disabled
     *  to forward packets.
     *  
     *  @param enabled if true, then the IPv4 unicast forwarding is enabled,
     *  otherwise is disabled.
     */
    virtual XrlCmdError fti_0_2_get_unicast_forwarding_enabled4(
	// Output values, 
	bool&	enabled) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Test whether the IPv6 unicast forwarding engine is enabled or disabled
     *  to forward packets.
     *  
     *  @param enabled if true, then the IPv6 unicast forwarding is enabled,
     *  otherwise is disabled.
     */
    virtual XrlCmdError fti_0_2_get_unicast_forwarding_enabled6(
	// Output values, 
	bool&	enabled) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Set the IPv4 unicast forwarding engine to enable or disable forwarding
     *  of packets.
     *  
     *  @param enabled if true, then enable IPv4 unicast forwarding, otherwise
     *  disable it.
     */
    virtual XrlCmdError fti_0_2_set_unicast_forwarding_enabled4(
	// Input values, 
	const bool&	enabled) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Set the IPv6 unicast forwarding engine to enable or disable forwarding
     *  of packets.
     *  
     *  @param enabled if true, then enable IPv6 unicast forwarding, otherwise
     *  disable it.
     */
    virtual XrlCmdError fti_0_2_set_unicast_forwarding_enabled6(
	// Input values, 
	const bool&	enabled) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Send a packet on a raw socket.
     */
    virtual XrlCmdError raw_packet_0_1_send4(
	// Input values, 
	const IPv4&	src_address, 
	const IPv4&	dst_address, 
	const string&	vif_name, 
	const uint32_t&	proto, 
	const uint32_t&	ttl, 
	const uint32_t&	tos, 
	const vector<uint8_t>&	options, 
	const vector<uint8_t>&	payload) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Send raw packet. Checksum is computed and applied before transmission.
     *  All the fields within the IPv4 header must be in network order.
     */
    virtual XrlCmdError raw_packet_0_1_send_raw4(
	// Input values, 
	const string&	vif_name, 
	const vector<uint8_t>&	packet) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Register to receive packets. The receiver is expected to support
     *  raw_socket_client/0.1 interface.
     */
    virtual XrlCmdError raw_packet_0_1_register_vif_receiver(
	// Input values, 
	const string&	router_name, 
	const string&	if_name, 
	const string&	vif_name, 
	const uint32_t&	proto) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Unregister stop receiving packets.
     *  
     *  @param proto Protocol number that the receiver is interested in.
     */
    virtual XrlCmdError raw_packet_0_1_unregister_vif_receiver(
	// Input values, 
	const string&	router_name, 
	const string&	if_name, 
	const string&	vif_name, 
	const uint32_t&	proto) = 0;

private:
    const XrlCmdError handle_common_0_1_get_target_name(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_common_0_1_get_version(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_common_0_1_get_status(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_common_0_1_shutdown(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_configured_interface_names(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_configured_vif_names(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_configured_vif_flags(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_configured_vif_pif_index(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_configured_vif_addresses4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_configured_vif_addresses6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_configured_address_flags4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_configured_address_flags6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_configured_interface_enabled(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_configured_mac(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_configured_mtu(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_configured_vif_enabled(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_configured_prefix4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_configured_broadcast4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_configured_endpoint4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_configured_prefix6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_configured_endpoint6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_start_transaction(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_commit_transaction(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_abort_transaction(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_create_interface(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_delete_interface(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_set_interface_enabled(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_set_mac(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_set_mtu(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_create_vif(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_delete_vif(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_set_vif_enabled(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_create_address4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_delete_address4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_set_address_enabled4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_configured_address_enabled4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_set_prefix4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_set_broadcast4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_set_endpoint4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_create_address6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_delete_address6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_set_address_enabled6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_configured_address_enabled6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_set_prefix6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_set_endpoint6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_register_client(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_unregister_client(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_system_interface_names(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_system_vif_names(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_system_vif_flags(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_system_vif_pif_index(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_system_vif_addresses4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_system_address_flags4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_system_vif_addresses6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_system_address_flags6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_system_interface_enabled(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_system_mac(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_system_mtu(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_system_vif_enabled(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_system_prefix4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_system_broadcast4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_system_endpoint4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_system_prefix6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_system_endpoint6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_system_address_enabled4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_get_system_address_enabled6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_register_system_interfaces_client(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_0_1_unregister_system_interfaces_client(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_replicator_0_1_register_ifmgr_mirror(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_ifmgr_replicator_0_1_unregister_ifmgr_mirror(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_start_transaction(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_commit_transaction(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_abort_transaction(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_add_entry4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_add_entry6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_delete_entry4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_delete_entry6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_delete_all_entries(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_delete_all_entries4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_delete_all_entries6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_lookup_route4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_lookup_route6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_lookup_entry4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_lookup_entry6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_have_ipv4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_have_ipv6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_get_unicast_forwarding_enabled4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_get_unicast_forwarding_enabled6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_set_unicast_forwarding_enabled4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_fti_0_2_set_unicast_forwarding_enabled6(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_raw_packet_0_1_send4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_raw_packet_0_1_send_raw4(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_raw_packet_0_1_register_vif_receiver(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_raw_packet_0_1_unregister_vif_receiver(const XrlArgs& in, XrlArgs* out);

    void add_handlers()
    {
	if (_cmds->add_handler("common/0.1/get_target_name", 
	    callback(this, &XrlFeaTargetBase::handle_common_0_1_get_target_name)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/common/0.1/get_target_name");
	}
	if (_cmds->add_handler("common/0.1/get_version", 
	    callback(this, &XrlFeaTargetBase::handle_common_0_1_get_version)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/common/0.1/get_version");
	}
	if (_cmds->add_handler("common/0.1/get_status", 
	    callback(this, &XrlFeaTargetBase::handle_common_0_1_get_status)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/common/0.1/get_status");
	}
	if (_cmds->add_handler("common/0.1/shutdown", 
	    callback(this, &XrlFeaTargetBase::handle_common_0_1_shutdown)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/common/0.1/shutdown");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_configured_interface_names", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_interface_names)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_configured_interface_names");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_configured_vif_names", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_vif_names)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_configured_vif_names");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_configured_vif_flags", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_vif_flags)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_configured_vif_flags");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_configured_vif_pif_index", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_vif_pif_index)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_configured_vif_pif_index");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_configured_vif_addresses4", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_vif_addresses4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_configured_vif_addresses4");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_configured_vif_addresses6", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_vif_addresses6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_configured_vif_addresses6");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_configured_address_flags4", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_address_flags4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_configured_address_flags4");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_configured_address_flags6", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_address_flags6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_configured_address_flags6");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_configured_interface_enabled", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_interface_enabled)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_configured_interface_enabled");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_configured_mac", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_mac)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_configured_mac");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_configured_mtu", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_mtu)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_configured_mtu");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_configured_vif_enabled", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_vif_enabled)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_configured_vif_enabled");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_configured_prefix4", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_prefix4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_configured_prefix4");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_configured_broadcast4", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_broadcast4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_configured_broadcast4");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_configured_endpoint4", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_endpoint4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_configured_endpoint4");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_configured_prefix6", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_prefix6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_configured_prefix6");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_configured_endpoint6", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_endpoint6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_configured_endpoint6");
	}
	if (_cmds->add_handler("ifmgr/0.1/start_transaction", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_start_transaction)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/start_transaction");
	}
	if (_cmds->add_handler("ifmgr/0.1/commit_transaction", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_commit_transaction)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/commit_transaction");
	}
	if (_cmds->add_handler("ifmgr/0.1/abort_transaction", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_abort_transaction)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/abort_transaction");
	}
	if (_cmds->add_handler("ifmgr/0.1/create_interface", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_create_interface)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/create_interface");
	}
	if (_cmds->add_handler("ifmgr/0.1/delete_interface", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_delete_interface)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/delete_interface");
	}
	if (_cmds->add_handler("ifmgr/0.1/set_interface_enabled", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_set_interface_enabled)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/set_interface_enabled");
	}
	if (_cmds->add_handler("ifmgr/0.1/set_mac", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_set_mac)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/set_mac");
	}
	if (_cmds->add_handler("ifmgr/0.1/set_mtu", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_set_mtu)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/set_mtu");
	}
	if (_cmds->add_handler("ifmgr/0.1/create_vif", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_create_vif)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/create_vif");
	}
	if (_cmds->add_handler("ifmgr/0.1/delete_vif", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_delete_vif)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/delete_vif");
	}
	if (_cmds->add_handler("ifmgr/0.1/set_vif_enabled", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_set_vif_enabled)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/set_vif_enabled");
	}
	if (_cmds->add_handler("ifmgr/0.1/create_address4", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_create_address4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/create_address4");
	}
	if (_cmds->add_handler("ifmgr/0.1/delete_address4", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_delete_address4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/delete_address4");
	}
	if (_cmds->add_handler("ifmgr/0.1/set_address_enabled4", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_set_address_enabled4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/set_address_enabled4");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_configured_address_enabled4", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_address_enabled4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_configured_address_enabled4");
	}
	if (_cmds->add_handler("ifmgr/0.1/set_prefix4", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_set_prefix4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/set_prefix4");
	}
	if (_cmds->add_handler("ifmgr/0.1/set_broadcast4", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_set_broadcast4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/set_broadcast4");
	}
	if (_cmds->add_handler("ifmgr/0.1/set_endpoint4", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_set_endpoint4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/set_endpoint4");
	}
	if (_cmds->add_handler("ifmgr/0.1/create_address6", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_create_address6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/create_address6");
	}
	if (_cmds->add_handler("ifmgr/0.1/delete_address6", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_delete_address6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/delete_address6");
	}
	if (_cmds->add_handler("ifmgr/0.1/set_address_enabled6", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_set_address_enabled6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/set_address_enabled6");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_configured_address_enabled6", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_address_enabled6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_configured_address_enabled6");
	}
	if (_cmds->add_handler("ifmgr/0.1/set_prefix6", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_set_prefix6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/set_prefix6");
	}
	if (_cmds->add_handler("ifmgr/0.1/set_endpoint6", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_set_endpoint6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/set_endpoint6");
	}
	if (_cmds->add_handler("ifmgr/0.1/register_client", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_register_client)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/register_client");
	}
	if (_cmds->add_handler("ifmgr/0.1/unregister_client", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_unregister_client)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/unregister_client");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_system_interface_names", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_system_interface_names)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_system_interface_names");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_system_vif_names", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_system_vif_names)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_system_vif_names");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_system_vif_flags", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_system_vif_flags)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_system_vif_flags");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_system_vif_pif_index", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_system_vif_pif_index)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_system_vif_pif_index");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_system_vif_addresses4", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_system_vif_addresses4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_system_vif_addresses4");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_system_address_flags4", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_system_address_flags4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_system_address_flags4");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_system_vif_addresses6", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_system_vif_addresses6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_system_vif_addresses6");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_system_address_flags6", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_system_address_flags6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_system_address_flags6");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_system_interface_enabled", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_system_interface_enabled)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_system_interface_enabled");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_system_mac", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_system_mac)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_system_mac");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_system_mtu", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_system_mtu)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_system_mtu");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_system_vif_enabled", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_system_vif_enabled)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_system_vif_enabled");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_system_prefix4", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_system_prefix4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_system_prefix4");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_system_broadcast4", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_system_broadcast4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_system_broadcast4");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_system_endpoint4", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_system_endpoint4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_system_endpoint4");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_system_prefix6", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_system_prefix6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_system_prefix6");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_system_endpoint6", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_system_endpoint6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_system_endpoint6");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_system_address_enabled4", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_system_address_enabled4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_system_address_enabled4");
	}
	if (_cmds->add_handler("ifmgr/0.1/get_system_address_enabled6", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_get_system_address_enabled6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/get_system_address_enabled6");
	}
	if (_cmds->add_handler("ifmgr/0.1/register_system_interfaces_client", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_register_system_interfaces_client)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/register_system_interfaces_client");
	}
	if (_cmds->add_handler("ifmgr/0.1/unregister_system_interfaces_client", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_0_1_unregister_system_interfaces_client)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr/0.1/unregister_system_interfaces_client");
	}
	if (_cmds->add_handler("ifmgr_replicator/0.1/register_ifmgr_mirror", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_replicator_0_1_register_ifmgr_mirror)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr_replicator/0.1/register_ifmgr_mirror");
	}
	if (_cmds->add_handler("ifmgr_replicator/0.1/unregister_ifmgr_mirror", 
	    callback(this, &XrlFeaTargetBase::handle_ifmgr_replicator_0_1_unregister_ifmgr_mirror)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/ifmgr_replicator/0.1/unregister_ifmgr_mirror");
	}
	if (_cmds->add_handler("fti/0.2/start_transaction", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_start_transaction)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/start_transaction");
	}
	if (_cmds->add_handler("fti/0.2/commit_transaction", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_commit_transaction)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/commit_transaction");
	}
	if (_cmds->add_handler("fti/0.2/abort_transaction", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_abort_transaction)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/abort_transaction");
	}
	if (_cmds->add_handler("fti/0.2/add_entry4", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_add_entry4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/add_entry4");
	}
	if (_cmds->add_handler("fti/0.2/add_entry6", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_add_entry6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/add_entry6");
	}
	if (_cmds->add_handler("fti/0.2/delete_entry4", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_delete_entry4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/delete_entry4");
	}
	if (_cmds->add_handler("fti/0.2/delete_entry6", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_delete_entry6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/delete_entry6");
	}
	if (_cmds->add_handler("fti/0.2/delete_all_entries", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_delete_all_entries)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/delete_all_entries");
	}
	if (_cmds->add_handler("fti/0.2/delete_all_entries4", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_delete_all_entries4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/delete_all_entries4");
	}
	if (_cmds->add_handler("fti/0.2/delete_all_entries6", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_delete_all_entries6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/delete_all_entries6");
	}
	if (_cmds->add_handler("fti/0.2/lookup_route4", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_lookup_route4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/lookup_route4");
	}
	if (_cmds->add_handler("fti/0.2/lookup_route6", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_lookup_route6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/lookup_route6");
	}
	if (_cmds->add_handler("fti/0.2/lookup_entry4", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_lookup_entry4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/lookup_entry4");
	}
	if (_cmds->add_handler("fti/0.2/lookup_entry6", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_lookup_entry6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/lookup_entry6");
	}
	if (_cmds->add_handler("fti/0.2/have_ipv4", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_have_ipv4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/have_ipv4");
	}
	if (_cmds->add_handler("fti/0.2/have_ipv6", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_have_ipv6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/have_ipv6");
	}
	if (_cmds->add_handler("fti/0.2/get_unicast_forwarding_enabled4", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_get_unicast_forwarding_enabled4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/get_unicast_forwarding_enabled4");
	}
	if (_cmds->add_handler("fti/0.2/get_unicast_forwarding_enabled6", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_get_unicast_forwarding_enabled6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/get_unicast_forwarding_enabled6");
	}
	if (_cmds->add_handler("fti/0.2/set_unicast_forwarding_enabled4", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_set_unicast_forwarding_enabled4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/set_unicast_forwarding_enabled4");
	}
	if (_cmds->add_handler("fti/0.2/set_unicast_forwarding_enabled6", 
	    callback(this, &XrlFeaTargetBase::handle_fti_0_2_set_unicast_forwarding_enabled6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/fti/0.2/set_unicast_forwarding_enabled6");
	}
	if (_cmds->add_handler("raw_packet/0.1/send4", 
	    callback(this, &XrlFeaTargetBase::handle_raw_packet_0_1_send4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/raw_packet/0.1/send4");
	}
	if (_cmds->add_handler("raw_packet/0.1/send_raw4", 
	    callback(this, &XrlFeaTargetBase::handle_raw_packet_0_1_send_raw4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/raw_packet/0.1/send_raw4");
	}
	if (_cmds->add_handler("raw_packet/0.1/register_vif_receiver", 
	    callback(this, &XrlFeaTargetBase::handle_raw_packet_0_1_register_vif_receiver)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/raw_packet/0.1/register_vif_receiver");
	}
	if (_cmds->add_handler("raw_packet/0.1/unregister_vif_receiver", 
	    callback(this, &XrlFeaTargetBase::handle_raw_packet_0_1_unregister_vif_receiver)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://fea/raw_packet/0.1/unregister_vif_receiver");
	}
	_cmds->finalize();
    }

    void remove_handlers()
    {
	_cmds->remove_handler("common/0.1/get_target_name");
	_cmds->remove_handler("common/0.1/get_version");
	_cmds->remove_handler("common/0.1/get_status");
	_cmds->remove_handler("common/0.1/shutdown");
	_cmds->remove_handler("ifmgr/0.1/get_configured_interface_names");
	_cmds->remove_handler("ifmgr/0.1/get_configured_vif_names");
	_cmds->remove_handler("ifmgr/0.1/get_configured_vif_flags");
	_cmds->remove_handler("ifmgr/0.1/get_configured_vif_pif_index");
	_cmds->remove_handler("ifmgr/0.1/get_configured_vif_addresses4");
	_cmds->remove_handler("ifmgr/0.1/get_configured_vif_addresses6");
	_cmds->remove_handler("ifmgr/0.1/get_configured_address_flags4");
	_cmds->remove_handler("ifmgr/0.1/get_configured_address_flags6");
	_cmds->remove_handler("ifmgr/0.1/get_configured_interface_enabled");
	_cmds->remove_handler("ifmgr/0.1/get_configured_mac");
	_cmds->remove_handler("ifmgr/0.1/get_configured_mtu");
	_cmds->remove_handler("ifmgr/0.1/get_configured_vif_enabled");
	_cmds->remove_handler("ifmgr/0.1/get_configured_prefix4");
	_cmds->remove_handler("ifmgr/0.1/get_configured_broadcast4");
	_cmds->remove_handler("ifmgr/0.1/get_configured_endpoint4");
	_cmds->remove_handler("ifmgr/0.1/get_configured_prefix6");
	_cmds->remove_handler("ifmgr/0.1/get_configured_endpoint6");
	_cmds->remove_handler("ifmgr/0.1/start_transaction");
	_cmds->remove_handler("ifmgr/0.1/commit_transaction");
	_cmds->remove_handler("ifmgr/0.1/abort_transaction");
	_cmds->remove_handler("ifmgr/0.1/create_interface");
	_cmds->remove_handler("ifmgr/0.1/delete_interface");
	_cmds->remove_handler("ifmgr/0.1/set_interface_enabled");
	_cmds->remove_handler("ifmgr/0.1/set_mac");
	_cmds->remove_handler("ifmgr/0.1/set_mtu");
	_cmds->remove_handler("ifmgr/0.1/create_vif");
	_cmds->remove_handler("ifmgr/0.1/delete_vif");
	_cmds->remove_handler("ifmgr/0.1/set_vif_enabled");
	_cmds->remove_handler("ifmgr/0.1/create_address4");
	_cmds->remove_handler("ifmgr/0.1/delete_address4");
	_cmds->remove_handler("ifmgr/0.1/set_address_enabled4");
	_cmds->remove_handler("ifmgr/0.1/get_configured_address_enabled4");
	_cmds->remove_handler("ifmgr/0.1/set_prefix4");
	_cmds->remove_handler("ifmgr/0.1/set_broadcast4");
	_cmds->remove_handler("ifmgr/0.1/set_endpoint4");
	_cmds->remove_handler("ifmgr/0.1/create_address6");
	_cmds->remove_handler("ifmgr/0.1/delete_address6");
	_cmds->remove_handler("ifmgr/0.1/set_address_enabled6");
	_cmds->remove_handler("ifmgr/0.1/get_configured_address_enabled6");
	_cmds->remove_handler("ifmgr/0.1/set_prefix6");
	_cmds->remove_handler("ifmgr/0.1/set_endpoint6");
	_cmds->remove_handler("ifmgr/0.1/register_client");
	_cmds->remove_handler("ifmgr/0.1/unregister_client");
	_cmds->remove_handler("ifmgr/0.1/get_system_interface_names");
	_cmds->remove_handler("ifmgr/0.1/get_system_vif_names");
	_cmds->remove_handler("ifmgr/0.1/get_system_vif_flags");
	_cmds->remove_handler("ifmgr/0.1/get_system_vif_pif_index");
	_cmds->remove_handler("ifmgr/0.1/get_system_vif_addresses4");
	_cmds->remove_handler("ifmgr/0.1/get_system_address_flags4");
	_cmds->remove_handler("ifmgr/0.1/get_system_vif_addresses6");
	_cmds->remove_handler("ifmgr/0.1/get_system_address_flags6");
	_cmds->remove_handler("ifmgr/0.1/get_system_interface_enabled");
	_cmds->remove_handler("ifmgr/0.1/get_system_mac");
	_cmds->remove_handler("ifmgr/0.1/get_system_mtu");
	_cmds->remove_handler("ifmgr/0.1/get_system_vif_enabled");
	_cmds->remove_handler("ifmgr/0.1/get_system_prefix4");
	_cmds->remove_handler("ifmgr/0.1/get_system_broadcast4");
	_cmds->remove_handler("ifmgr/0.1/get_system_endpoint4");
	_cmds->remove_handler("ifmgr/0.1/get_system_prefix6");
	_cmds->remove_handler("ifmgr/0.1/get_system_endpoint6");
	_cmds->remove_handler("ifmgr/0.1/get_system_address_enabled4");
	_cmds->remove_handler("ifmgr/0.1/get_system_address_enabled6");
	_cmds->remove_handler("ifmgr/0.1/register_system_interfaces_client");
	_cmds->remove_handler("ifmgr/0.1/unregister_system_interfaces_client");
	_cmds->remove_handler("ifmgr_replicator/0.1/register_ifmgr_mirror");
	_cmds->remove_handler("ifmgr_replicator/0.1/unregister_ifmgr_mirror");
	_cmds->remove_handler("fti/0.2/start_transaction");
	_cmds->remove_handler("fti/0.2/commit_transaction");
	_cmds->remove_handler("fti/0.2/abort_transaction");
	_cmds->remove_handler("fti/0.2/add_entry4");
	_cmds->remove_handler("fti/0.2/add_entry6");
	_cmds->remove_handler("fti/0.2/delete_entry4");
	_cmds->remove_handler("fti/0.2/delete_entry6");
	_cmds->remove_handler("fti/0.2/delete_all_entries");
	_cmds->remove_handler("fti/0.2/delete_all_entries4");
	_cmds->remove_handler("fti/0.2/delete_all_entries6");
	_cmds->remove_handler("fti/0.2/lookup_route4");
	_cmds->remove_handler("fti/0.2/lookup_route6");
	_cmds->remove_handler("fti/0.2/lookup_entry4");
	_cmds->remove_handler("fti/0.2/lookup_entry6");
	_cmds->remove_handler("fti/0.2/have_ipv4");
	_cmds->remove_handler("fti/0.2/have_ipv6");
	_cmds->remove_handler("fti/0.2/get_unicast_forwarding_enabled4");
	_cmds->remove_handler("fti/0.2/get_unicast_forwarding_enabled6");
	_cmds->remove_handler("fti/0.2/set_unicast_forwarding_enabled4");
	_cmds->remove_handler("fti/0.2/set_unicast_forwarding_enabled6");
	_cmds->remove_handler("raw_packet/0.1/send4");
	_cmds->remove_handler("raw_packet/0.1/send_raw4");
	_cmds->remove_handler("raw_packet/0.1/register_vif_receiver");
	_cmds->remove_handler("raw_packet/0.1/unregister_vif_receiver");
    }
};

#endif /* __XRL_INTERFACES_FEA_BASE_HH__ */
