/*
 * Copyright (c) 2001-2003 International Computer Science Institute
 * See LICENSE file for licensing, conditions, and warranties on use.
 *
 * DO NOT EDIT THIS FILE - IT IS PROGRAMMATICALLY GENERATED
 *
 * Generated by 'tgt-gen'.
 *
 * $XORP: xorp/xrl/targets/test_peer_base.hh,v 1.12 2003/06/26 19:41:50 atanu Exp $
 */


#ifndef __XRL_INTERFACES_TEST_PEER_BASE_HH__
#define __XRL_INTERFACES_TEST_PEER_BASE_HH__

#undef XORP_LIBRARY_NAME
#define XORP_LIBRARY_NAME "XrlTestPeerTarget"

#include "libxorp/xlog.h"
#include "libxipc/xrl_cmd_map.hh"

class XrlTestPeerTargetBase {
protected:
    XrlCmdMap* _cmds;

public:
    XrlTestPeerTargetBase(XrlCmdMap* cmds) : _cmds(cmds) { add_handlers(); }
    virtual ~XrlTestPeerTargetBase() { remove_handlers(); }

    inline const string& name() const { return _cmds->name(); }
    inline const char* version() const { return "test_peer/0.0"; }

protected:

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get name of Xrl Target
     */
    virtual XrlCmdError common_0_1_get_target_name(
	// Output values, 
	string&	name) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get version string from Xrl Target
     */
    virtual XrlCmdError common_0_1_get_version(
	// Output values, 
	string&	version) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get status of Xrl Target
     */
    virtual XrlCmdError common_0_1_get_status(
	// Output values, 
	uint32_t&	status, 
	string&	reason) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Request clean shutdown of Xrl Target
     */
    virtual XrlCmdError common_0_1_shutdown() = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Register for receiving packets and events.
     *  
     *  @param genid Generation id.
     */
    virtual XrlCmdError test_peer_0_1_register(
	// Input values, 
	const string&	coordinator, 
	const uint32_t&	genid) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Packetisation style.
     */
    virtual XrlCmdError test_peer_0_1_packetisation(
	// Input values, 
	const string&	protocol) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Make a tcp connection to the specified host and port.
     *  
     *  @param host name.
     *  
     *  @param port number.
     */
    virtual XrlCmdError test_peer_0_1_connect(
	// Input values, 
	const string&	host, 
	const uint32_t&	port) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Listen for connections on this address and port.
     *  
     *  @param address local address.
     *  
     *  @param port local port number.
     */
    virtual XrlCmdError test_peer_0_1_listen(
	// Input values, 
	const string&	address, 
	const uint32_t&	port) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Send data Send data to the peer.
     */
    virtual XrlCmdError test_peer_0_1_send(
	// Input values, 
	const vector<uint8_t>&	data) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Disconnect from the peer.
     */
    virtual XrlCmdError test_peer_0_1_disconnect() = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Reset the peer. Take it back to a known state.
     */
    virtual XrlCmdError test_peer_0_1_reset() = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Terminate the test peer process.
     */
    virtual XrlCmdError test_peer_0_1_terminate() = 0;

private:
    const XrlCmdError handle_common_0_1_get_target_name(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_common_0_1_get_version(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_common_0_1_get_status(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_common_0_1_shutdown(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_test_peer_0_1_register(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_test_peer_0_1_packetisation(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_test_peer_0_1_connect(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_test_peer_0_1_listen(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_test_peer_0_1_send(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_test_peer_0_1_disconnect(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_test_peer_0_1_reset(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_test_peer_0_1_terminate(const XrlArgs& in, XrlArgs* out);

    void add_handlers()
    {
	if (_cmds->add_handler("common/0.1/get_target_name", 
	    callback(this, &XrlTestPeerTargetBase::handle_common_0_1_get_target_name)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/common/0.1/get_target_name");
	}
	if (_cmds->add_handler("common/0.1/get_version", 
	    callback(this, &XrlTestPeerTargetBase::handle_common_0_1_get_version)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/common/0.1/get_version");
	}
	if (_cmds->add_handler("common/0.1/get_status", 
	    callback(this, &XrlTestPeerTargetBase::handle_common_0_1_get_status)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/common/0.1/get_status");
	}
	if (_cmds->add_handler("common/0.1/shutdown", 
	    callback(this, &XrlTestPeerTargetBase::handle_common_0_1_shutdown)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/common/0.1/shutdown");
	}
	if (_cmds->add_handler("test_peer/0.1/register", 
	    callback(this, &XrlTestPeerTargetBase::handle_test_peer_0_1_register)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/test_peer/0.1/register");
	}
	if (_cmds->add_handler("test_peer/0.1/packetisation", 
	    callback(this, &XrlTestPeerTargetBase::handle_test_peer_0_1_packetisation)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/test_peer/0.1/packetisation");
	}
	if (_cmds->add_handler("test_peer/0.1/connect", 
	    callback(this, &XrlTestPeerTargetBase::handle_test_peer_0_1_connect)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/test_peer/0.1/connect");
	}
	if (_cmds->add_handler("test_peer/0.1/listen", 
	    callback(this, &XrlTestPeerTargetBase::handle_test_peer_0_1_listen)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/test_peer/0.1/listen");
	}
	if (_cmds->add_handler("test_peer/0.1/send", 
	    callback(this, &XrlTestPeerTargetBase::handle_test_peer_0_1_send)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/test_peer/0.1/send");
	}
	if (_cmds->add_handler("test_peer/0.1/disconnect", 
	    callback(this, &XrlTestPeerTargetBase::handle_test_peer_0_1_disconnect)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/test_peer/0.1/disconnect");
	}
	if (_cmds->add_handler("test_peer/0.1/reset", 
	    callback(this, &XrlTestPeerTargetBase::handle_test_peer_0_1_reset)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/test_peer/0.1/reset");
	}
	if (_cmds->add_handler("test_peer/0.1/terminate", 
	    callback(this, &XrlTestPeerTargetBase::handle_test_peer_0_1_terminate)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/test_peer/0.1/terminate");
	}
	_cmds->finalize();
    }

    void remove_handlers()
    {
	_cmds->remove_handler("common/0.1/get_target_name");
	_cmds->remove_handler("common/0.1/get_version");
	_cmds->remove_handler("common/0.1/get_status");
	_cmds->remove_handler("common/0.1/shutdown");
	_cmds->remove_handler("test_peer/0.1/register");
	_cmds->remove_handler("test_peer/0.1/packetisation");
	_cmds->remove_handler("test_peer/0.1/connect");
	_cmds->remove_handler("test_peer/0.1/listen");
	_cmds->remove_handler("test_peer/0.1/send");
	_cmds->remove_handler("test_peer/0.1/disconnect");
	_cmds->remove_handler("test_peer/0.1/reset");
	_cmds->remove_handler("test_peer/0.1/terminate");
    }
};

#endif /* __XRL_INTERFACES_TEST_PEER_BASE_HH__ */
